/*
 * Proyecto: MovingBox
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 08/06/2023
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oBevel1

   METHOD CreateForm()
   METHOD Bevel1LButtonDown( oSender, nKeyFlags, nPosX, nPosY )

   DATA lMoving INIT .F.
   DATA nPosX, nPosY INIT 0

   METHOD Bevel1MouseMove( oSender, nKeyFlags, nPosX, nPosY )
   METHOD Bevel1LButtonUp( oSender, nKeyFlags, nPosX, nPosY )
   METHOD FormKeyDown( oSender, nKey, nFlags )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD Bevel1LButtonDown( oSender, nKeyFlags, nPosX, nPosY ) CLASS TForm1

   ::lMoving := .t.
   ::nPosX := nPosX
   ::nPosY := nPosY
   SetCapture( oSender:Handle )

RETURN Nil

//------------------------------------------------------------------------------

METHOD Bevel1MouseMove( oSender, nKeyFlags, nPosX, nPosY ) CLASS TForm1

   IF ::lMoving
      WITH OBJECT oSender
         :SetBounds( :nLeft + nPosX - ::nPosX, :nTop + nPosY - ::nPosY )
      END WITH
      ::lAutoScroll := .T.
   ENDIF

RETURN Nil

//------------------------------------------------------------------------------

METHOD Bevel1LButtonUp( oSender, nKeyFlags, nPosX, nPosY ) CLASS TForm1

   IF ::lMoving
      ::lMoving := .F.
      ReleaseCapture()
   ENDIF

RETURN Nil

//------------------------------------------------------------------------------

METHOD FormKeyDown( oSender, nKey, nFlags ) CLASS TForm1

   SWITCH nKey
   CASE VK_DOWN
      ::oBevel1:nTop++
      EXIT
   CASE VK_LEFT
      ::oBevel1:nLeft--
      EXIT
   CASE VK_RIGHT
      ::oBevel1:nLeft++
      EXIT
   CASE VK_UP
      ::oBevel1:nTop--
      EXIT
   END SWITCH

RETURN Nil

//------------------------------------------------------------------------------
